//untested

/*	Sample program for Olimex AVR-P20 with AT90S2313 processor
 *	Echoes back the received characters on the uart. In order to work,
 *	connect the RX pad with PD1(pin 3) and TX pad with PD0(pin 2)
 *	Compile with AVRStudio+WinAVR (gcc version 3.4.6)
 */

#define	__AVR_AT90S2313__	1
#define OSCSPEED	10000000		/* in Hz */


/*#define UBRR	_SFR_IO8(0x09)
#define UCR	_SFR_IO8(0x0A)
#define USR	_SFR_IO8(0x0B)
#define UDR	_SFR_IO8(0x0C)*/

#include "avr/io.h"

void PORT_Init()
{
	PORTB = 0b10000000;
	DDRB  = 0b10000000;

	PORTD = 0b00000000;
	DDRD  = 0b00000010;		//set TX as output
}

void UART_Init(uint32_t Baud)
{
	//calculate BaudRate (Datasheet page 44)
	unsigned int BaudRate = OSCSPEED / (16 * Baud) - 1;
	UBRR = BaudRate;			//set BaudRate into register
	UCR  = UCR | 0b00011000;	//enable Transmitter (Bit3 = 1) and Receiver (Bit4 = 1)
}


void UART_Transmit(unsigned char Data)
{
	while (!(USR & 0b00100000));
	UDR = Data;
}

unsigned char UART_Receive()
{
	if (USR & 0b10000000)
		return UDR;
	else
		return 0;
}

int main()
{
	PORT_Init();
	UART_Init(9600);
	unsigned char Ch=0;
	while (1)
	{
		Ch = UART_Receive();
		if (Ch)
		{
			UART_Transmit(Ch);
		}
	}	
	return 0;
}
